local function EsoBR_doubleNamesBoth(EsoBR)
	local GetGameCameraInteractableActionInfoOld = GetGameCameraInteractableActionInfo
	local prevInteractNpcEn = ""
	local prevInteractNpcBr = ""
		
	function GetGameCameraInteractableActionInfo(...)
		local action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract = GetGameCameraInteractableActionInfoOld()
		local newNpcName, temp1, temp2, interactionType, settingType
				
		if action == GetString(SI_GAMECAMERAACTIONTYPE2) or action == GetString(SI_GAMECAMERAACTIONTYPE21) or action == GetString(SI_GAMECAMERAACTIONTYPE1) or action == GetString(SI_GAMECAMERAACTIONTYPE7) then
			interactionType = "npc"
			settingType = EsoBR.Settings.ShowNPC
		else
			interactionType = "location"
			settingType = EsoBR.Settings.ShowMatColeta
		end
		
		if settingType == "Somente Português" or interactableName == nil then
			return action, ZO_CachedStrFormat(SI_ZONE_NAME, interactableName), interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract
		end
		
		temp1 = prevInteractNpcBr .. " (" .. prevInteractNpcEn .. ")"
		temp2 = prevInteractNpcEn .. " (" .. prevInteractNpcBr .. ")"
		
		if interactableName == prevInteractNpcBr or interactableName == temp1 or interactableName == temp2 then
			newNpcName = prevInteractNpcEn
		elseif interactableName == prevInteractNpcEn and settingType == "Somente Inglês" then
			newNpcName = prevInteractNpcEn
		else
			if interactionType == "npc" then
				newNpcName = npcNames[zo_strlower(interactableName)]
			else
				newNpcName = coletaveisNames[zo_strlower(interactableName)]
			end
				
			if (newNpcName ~= nil and interactableName ~= nil) then
				prevInteractNpcEn = newNpcName
				prevInteractNpcBr = interactableName
			end
		end
		
		if newNpcName ~= nil then
			if (settingType == "Português+Inglês") then
				interactableName = ZO_CachedStrFormat(SI_ZONE_NAME, interactableName) .. "\n|ce0d210" .. newNpcName
			elseif (settingType == "Inglês+Português") then
				interactableName = newNpcName .. "\n|ce0d210" .. ZO_CachedStrFormat(SI_ZONE_NAME, interactableName) 
			else
				interactableName = newNpcName
			end 
		end
		
		return action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract
	end
	
	EsoBR_doubleNamesBoth = nil
end

local function EsoBR_doubleNamesMatColeta(EsoBR)
	
	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
			
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local matColeta = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (matColeta == nil or EsoBR.Settings.ShowMatColeta == "Somente Português") then
			return matColeta
		end
		
		newColName = coletaveisNames[zo_strlower(matColeta)]
			
		if newColName ~= nil then
			if (EsoBR.Settings.ShowMatColeta == "Português+Inglês") then
				matColeta = matColeta .. "\n|ca99e83" .. newColName .. "|r"
			elseif (EsoBR.Settings.ShowMatColeta == "Inglês+Português") then
				matColeta = newColName .. "\n|ca99e83" .. matColeta .. "|r"
			else
				matColeta = newColName
			end
		end
			
		return matColeta
	end
	
	EsoBR_doubleNamesMatColeta = nil
end

function EsoBR_doubleNamesNPC(EsoBR)
	
	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end

	local GetUnitNameOld = GetUnitName

	function GetUnitName(target)
		
		local currentNpcName = GetUnitNameOld(target)
		local newNpcName
		
		if (target == "player" or EsoBR.Settings.ShowNPC == "Somente Português" or currentNpcName == nil) then
			return currentNpcName
		end
		
		if (target == "reticleover") then
			if (not DoesUnitExist("reticleover") or IsUnitPlayer("reticleover")) then return currentNpcName end
		end
		
		newNpcName = npcNames[zo_strlower(currentNpcName)]
			
		if newNpcName ~= nil then
			if (EsoBR.Settings.ShowNPC == "Português+Inglês") then
				currentNpcName = currentNpcName .. " (" .. newNpcName .. ")"
			elseif (EsoBR.Settings.ShowNPC == "Inglês+Português") then
				currentNpcName = newNpcName .. " (" .. currentNpcName .. ")"
			else
				currentNpcName = newNpcName
			end
		end
			
		return currentNpcName
	end
	
	local GetMapLocationTooltipLineInfoOld = GetMapLocationTooltipLineInfo
	
	function GetMapLocationTooltipLineInfo(...)
		local icon, name, groupingId, categoryName = GetMapLocationTooltipLineInfoOld(...)
		
		if (name == nil or EsoBR.Settings.ShowNPC == "Somente Português") then
			return icon, name, groupingId, categoryName
		end
		
		newNpcName = npcNames[zo_strlower(name)]
			
		if newNpcName ~= nil then
			if (EsoBR.Settings.ShowNPC == "Português+Inglês") then
				name = name .. "\n|ca99e83" .. newNpcName .. "|r"
			elseif (EsoBR.Settings.ShowNPC == "Inglês+Português") then
				name = newNpcName .. "\n|ca99e83" .. name .. "|r"
			else
				name = newNpcName
			end
		end
			
		return icon, name, groupingId, categoryName
	end
	
	EsoBR_doubleNamesNPC = nil
end

function EsoBR_doubleNamesLocations(EsoBR)
	
	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
--[[
	----Third-party Compatibility
	AwesomeGuildStore
	local AGSform1 = "|ca99e83"
	local AGSform2 = "|r"
	
	if EsoBR:IsAddonRunning("AwesomeGuildStore") then
		if AwesomeGuildStore.class.StoreLocationHelper then
			ZO_PreHook(AwesomeGuildStore.class.StoreLocationHelper, "CollectStoresOnCurrentMap", function()
				AGSform1 = ""
				AGSform2 = ""
			end)
			ZO_PreHook(AwesomeGuildStore.class.StoreLocationHelper, "UpdateKioskAndStore", function()
				AGSform1 = ""
				AGSform2 = ""
			end)
			ZO_PostHook(AwesomeGuildStore.class.StoreLocationHelper, "CollectStoresOnCurrentMap", function()
				AGSform1 = "|ca99e83"
				AGSform2 = "|r"
			end)
			ZO_PostHook(AwesomeGuildStore.class.StoreLocationHelper, "UpdateKioskAndStore", function()
				AGSform1 = "|ca99e83"
				AGSform2 = "|r"
			end)
		end
	end
	
	------ EasyTravel
	if EsoBR:IsAddonRunning("EasyTravel") then
		local ShowLocationsBackup
		
		if EasyTravel.PlayerList.Rebuild then
			ZO_PreHook(EasyTravel.PlayerList, "Rebuild", function()
				ShowLocationsBackup = EsoBR.Settings.ShowLocations
				EsoBR.Settings.ShowLocations = "Somente Português"
			end)
			
			ZO_PostHook(EasyTravel.PlayerList, "Rebuild", function()
				EsoBR.Settings.ShowLocations = ShowLocationsBackup
			end)
		end
	end
	-----Third-party Compatibility
	
	local GetMapLocationTooltipHeaderOld = GetMapLocationTooltipHeader
	
	function GetMapLocationTooltipHeader(...)
		local headerText = ZO_CachedStrFormat(SI_ZONE_NAME, GetMapLocationTooltipHeaderOld(...))
		
		if (headerText == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return headerText
		end
		
		newLocName = locationNames[zo_strlower(headerText)]
		
		if newLocName ~= nil then
			if EsoBR.Settings.ShowLocations == "Português+Inglês" then
				headerText = headerText .. "\n" .. AGSform1 .. newLocName .. AGSform2
			elseif EsoBR.Settings.ShowLocations == "Inglês+Português" then
				headerText = newLocName .. "\n" .. AGSform1 .. headerText .. AGSform2
			else
				headerText = newLocName
			end
		end
		
		return headerText
	end
	--]]
	local GetPOIInfoOld = GetPOIInfo
	
	function GetPOIInfo(...)
		local poiName, _, poiStartDesc, poiFinishedDesc = GetPOIInfoOld(...)
		
		if (poiName == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return ZO_CachedStrFormat(SI_ZONE_NAME, poiName), _, poiStartDesc, poiFinishedDesc
		end
		
		newLocName = locationNames[zo_strlower(poiName)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				poiName = ZO_CachedStrFormat(SI_ZONE_NAME, poiName) .. " (" .. newLocName .. ")" 
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				poiName = newLocName .. " (" .. zo_strformat("<<1>>", poiName) .. ")"
			else
				poiName = newLocName
			end
		end
		
		return poiName, _, poiStartDesc, poiFinishedDesc
	end
	
	local GetMapMouseoverInfoOld = GetMapMouseoverInfo
	
	function GetMapMouseoverInfo(...)
		local locationName, textureFile, widthN, heightN, locXN, locYN = GetMapMouseoverInfoOld(...)
		
		if (locationName == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return ZO_CachedStrFormat(SI_ZONE_NAME, locationName), textureFile, widthN, heightN, locXN, locYN
		end
		
		newLocName = locationNames[zo_strlower(locationName)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				locationName = ZO_CachedStrFormat(SI_ZONE_NAME, locationName) .. "\n" .. newLocName
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				locationName = newLocName .. "\n" .. ZO_CachedStrFormat(SI_ZONE_NAME, locationName)
			else
				locationName = newLocName
			end
		end
		
		return locationName, textureFile, widthN, heightN, locXN, locYN
	end
	
	local GetMapNameOld = GetMapName
	
	function GetMapName(...)
		local zoneName = GetMapNameOld(...)
		
		if (zoneName == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return zoneName
		end
		
		newLocName = locationNames[zo_strlower(zoneName)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				zoneName = ZO_CachedStrFormat(SI_ZONE_NAME, zoneName) .. "\n" .. newLocName
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				zoneName = newLocName .. "\n" .. ZO_CachedStrFormat(SI_ZONE_NAME, zoneName)
			else
				zoneName = newLocName
			end
		end
		
		return zoneName
	end
	
	local GetFastTravelNodeInfoOld = GetFastTravelNodeInfo
	
	function GetFastTravelNodeInfo(...)
		local known, name, normalizedX, normalizedY, icon, glowIcon, poiType, isLocatedInCurrentMap, linkedCollectibleIsLocked = GetFastTravelNodeInfoOld(...)
		
		if (name == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return known, name, normalizedX, normalizedY, icon, glowIcon, poiType, isLocatedInCurrentMap, linkedCollectibleIsLocked
		end
		
		newLocName = locationNames[zo_strlower(name)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				name = name .. "\n(" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				name = newLocName .. "\n(" .. name .. ")"
			else
				name = newLocName
			end
		end
		
		return known, name, normalizedX, normalizedY, icon, glowIcon, poiType, isLocatedInCurrentMap, linkedCollectibleIsLocked
	end
	
	local GetKeepNameOld = GetKeepName
	
	function GetKeepName(...)
		local name = ZO_CachedStrFormat(SI_ZONE_NAME, GetKeepNameOld(...))
		
		if (name == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return name
		end
		
		newLocName = locationNames[zo_strlower(name)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				name = name .. "\n(" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				name = newLocName .. "\n(" .. name .. ")"
			else
				name = newLocName
			end
		end
		
		return name
	end
	
	local GetMapInfoOld = GetMapInfoByIndex
	
	function GetMapInfoByIndex(...)
		local mapName, mapType, mapContentType, zoneId, description = GetMapInfoOld(...)
		
		if (mapName == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return mapName, mapType, mapContentType, zoneId, description
		end
		
		newLocName = locationNames[zo_strlower(mapName)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				mapName = mapName .. " (" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				mapName = newLocName .. " (" .. mapName .. ")"
			else
				mapName = newLocName
			end
		end
		
		return mapName, mapType, mapContentType, zoneId, description
	end
	
	local GetFriendCharacterInfoOld = GetFriendCharacterInfo
	
	local function GetFriendCharacterInfoNew(...)
		local hasCharacter, characterName, zone, class, alliance, level, championPoints, zoneId = GetFriendCharacterInfoOld(...)
		
		if (zone == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return hasCharacter, characterName, zone, class, alliance, level, championPoints, zoneId
		end
		
		zone = ZO_CachedStrFormat(SI_ZONE_NAME, zone)
		
		newLocName = locationNames[zo_strlower(zone)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				zone = zone .. " (" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				zone = newLocName .. " (" .. zone .. ")"
			else
				zone = newLocName
			end
		end
		
		return hasCharacter, characterName, zone, class, alliance, level, championPoints, zoneId
	end
	
	ZO_PreHook(FRIENDS_LIST_MANAGER, "BuildMasterList", function()
		GetFriendCharacterInfo = GetFriendCharacterInfoNew
	end)
	
	ZO_PostHook(FRIENDS_LIST_MANAGER, "BuildMasterList", function()
		GetFriendCharacterInfo = GetFriendCharacterInfoOld
	end)
	
	FRIENDS_LIST_MANAGER:BuildMasterList()
	
	ZO_PostHook(FRIENDS_LIST_MANAGER, "OnFriendCharacterZoneChanged", function(tooltip, displayName, characterName, zoneName)
		local data = tooltip:FindDataByDisplayName(displayName)
		
		if data then
			local oldLocation = data.formattedZone
			local newLocName = locationNames[zo_strlower(oldLocation)]
			
			if newLocName ~= nil then
				if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
					data.formattedZone = oldLocation .. " (" .. newLocName .. ")"
				elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
					data.formattedZone = newLocName .. " (" .. oldLocation .. ")"
				else
					data.formattedZone = newLocName
				end
				
				tooltip:RefreshSort()
			end
		end
	end)
	
	local GetZoneNameByIndexOld = GetZoneNameByIndex
	
	function GetZoneNameByIndex(...)
		local zone = GetZoneNameByIndexOld(...)
		
		if (zone == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return zone
		end
		
		zone = ZO_CachedStrFormat(SI_ZONE_NAME, zone)
		
		newLocName = locationNames[zo_strlower(zone)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				zone = zone .. " (" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				zone = newLocName .. " (" .. zone .. ")"
			else
				zone = newLocName
			end
		end
		
		return zone
	end
	
	local GetActivityInfoOld = GetActivityInfo
	
	function GetActivityInfo(...)
		local name, levelMin, levelMax, championPointsMin, championPointsMax, groupType, minGroupSize, description, sortOrder = GetActivityInfoOld(...)
		
		if (name == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return name, levelMin, levelMax, championPointsMin, championPointsMax, groupType, minGroupSize, description, sortOrder
		end
		
		name = ZO_CachedStrFormat(SI_ZONE_NAME, name)
		
		newLocName = locationNames[zo_strlower(name)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				name = name .. " (" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				name = newLocName .. " (" .. name .. ")"
			else
				name = newLocName
			end
		end
		
		return name, levelMin, levelMax, championPointsMin, championPointsMax, groupType, minGroupSize, description, sortOrder
	end
	
	local GetGuildMemberCharacterInfoOld = GetGuildMemberCharacterInfo
	
	local function GetGuildMemberCharacterInfoNew(...)
		local hasCharacter, rawCharacterName, zone, class, alliance, level, championPoints, zoneId = GetGuildMemberCharacterInfoOld(...)
		
		if (zone == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return hasCharacter, rawCharacterName, zone, class, alliance, level, championPoints, zoneId
		end
		
		zone = ZO_CachedStrFormat(SI_ZONE_NAME, zone)
		
		newLocName = locationNames[zo_strlower(zone)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				zone = zone .. " (" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				zone = newLocName .. " (" .. zone .. ")"
			else
				zone = newLocName
			end
		end
		
		return hasCharacter, rawCharacterName, zone, class, alliance, level, championPoints, zoneId
	end
	
	ZO_PreHook(GUILD_ROSTER_MANAGER, "BuildMasterList", function()
		GetGuildMemberCharacterInfo = GetGuildMemberCharacterInfoNew
	end)
	
	ZO_PostHook(GUILD_ROSTER_MANAGER, "BuildMasterList", function()
		GetGuildMemberCharacterInfo = GetGuildMemberCharacterInfoOld
	end)
	
	GUILD_ROSTER_MANAGER:BuildMasterList()
	
	ZO_PostHook(GUILD_ROSTER_MANAGER, "OnGuildMemberPlayerStatusChanged", function(tooltip, displayName, oldStatus, newStatus)
		local data = tooltip:FindDataByDisplayName(displayName)
		local isOnline = (newStatus ~= PLAYER_STATUS_OFFLINE)
		
		if data and isOnline then
			local oldLocation = data.formattedZone
			local newLocName = locationNames[zo_strlower(oldLocation)]
			
			if newLocName ~= nil then
				if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
					data.formattedZone = oldLocation .. " (" .. newLocName .. ")"
				elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
					data.formattedZone = newLocName .. " (" .. oldLocation .. ")"
				else
					data.formattedZone = newLocName
				end
				
				tooltip:RefreshFilters()
			end
		end
	end)

	ZO_PostHook(GUILD_ROSTER_MANAGER, "OnGuildMemberCharacterZoneChanged", function(tooltip, displayName, characterName, zone)
		local data = tooltip:FindDataByDisplayName(displayName)
		
		if data then
			local oldLocation = data.formattedZone
			local newLocName = locationNames[zo_strlower(oldLocation)]
			
			if newLocName ~= nil then
				if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
					data.formattedZone = oldLocation .. " (" .. newLocName .. ")"
				elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
					data.formattedZone = newLocName .. " (" .. oldLocation .. ")"
				else
					data.formattedZone = newLocName
				end
				
				tooltip:RefreshSort()
			end
		end
	end)
	
	local GetCadwellZoneInfoOld = GetCadwellZoneInfo
	
	function GetCadwellZoneInfo(...)
		local zone, zoneDescription, zoneOrder = GetCadwellZoneInfoOld(...)
		
		if (zone == nil or EsoBR.Settings.ShowLocations == "Somente Português") then
			return zone, zoneDescription, zoneOrder
		end
		
		newLocName = locationNames[zo_strlower(zone)]
			
		if newLocName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				zone = zone .. " (" .. newLocName .. ")"
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				zone = newLocName .. " (" .. zone .. ")"
			else
				zone = newLocName
			end
		end
		
		return zone, zoneDescription, zoneOrder
	end
	
	CADWELLS_ALMANAC:RefreshList()
	EsoBR:MapNameStyle()
	
	local ZO_AlertText_GetHandlersOld = ZO_AlertText_GetHandlers
	
	function ZO_AlertText_GetHandlers()
		local ALERT = UI_ALERT_CATEGORY_ALERT
		local handlers = ZO_AlertText_GetHandlersOld()
		
		handlers[EVENT_ZONE_CHANGED] = function(zoneName, subzoneName)
			if(subzoneName ~= "") then
				if (EsoBR.Settings.ShowLocations ~= "Somente Português") then
					newLocName = locationNames[zo_strlower(subzoneName)]
			
					if newLocName ~= nil then
						if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
							subzoneName = subzoneName .. "\n|ca99e83" .. newLocName .. "|r"
						elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
							subzoneName = newLocName .. "\n|ca99e83" .. ZO_CachedStrFormat(SI_ZONE_NAME, subzoneName) .. "|r"
						else
							subzoneName = newLocName
						end
					end
				end
				
				return ALERT, ZO_CachedStrFormat(SI_ALERTTEXT_LOCATION_FORMAT, subzoneName)
			elseif(zoneName ~= "") then
				if (EsoBR.Settings.ShowLocations ~= "Somente Português") then
					newLocName = locationNames[zo_strlower(zoneName)]
			
					if newLocName ~= nil then
						if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
							zoneName = zoneName .. "\n|ca99e83" .. newLocName .. "|r"
						elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
							zoneName = newLocName .. "\n|ca99e83" .. ZO_CachedStrFormat(SI_ZONE_NAME, zoneName) .. "|r"
						else
							zoneName = newLocName
						end
					end
				end
				
				return ALERT, ZO_CachedStrFormat(SI_ALERTTEXT_LOCATION_FORMAT, zoneName)
			end
		end
		
		return handlers
	end
	
	LFGDoubleNames(EsoBR)
	
	EsoBR_doubleNamesLocations = nil
end

function LFGDoubleNames(EsoBR)
	local locs2 = ZO_ACTIVITY_FINDER_ROOT_MANAGER.sortedLocationsData[2] -- Normal Dungeons
	local locs3 = ZO_ACTIVITY_FINDER_ROOT_MANAGER.sortedLocationsData[3] -- Vet Dungeons
	
	for i = 1, #locs2 do	   
	   newLocationName = locationNames[zo_strlower(locs2[i]["rawName"])]
	   
	   if newLocationName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				locs2[i]["nameKeyboard"] = ZO_CachedStrFormat(SI_ZONE_NAME, locs2[i]["rawName"] .. " (" .. newLocationName .. ")")
				locs2[i]["nameGamepad"] = ZO_CachedStrFormat(SI_ZONE_NAME, locs2[i]["rawName"] .. " (" .. newLocationName .. ")")
			elseif (EsoBR.Settings.ShowLocations == "Somente Português") then
				locs2[i]["nameKeyboard"] = ZO_CachedStrFormat(SI_ZONE_NAME, locs2[i]["rawName"])
				locs2[i]["nameGamepad"] = ZO_CachedStrFormat(SI_ZONE_NAME, locs2[i]["rawName"])
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				locs2[i]["nameKeyboard"] = ZO_CachedStrFormat(SI_ZONE_NAME, newLocationName .. " (" .. locs2[i]["rawName"] .. ")")
				locs2[i]["nameGamepad"] = ZO_CachedStrFormat(SI_ZONE_NAME, newLocationName .. " (" .. locs2[i]["rawName"] .. ")")
			else
				locs2[i]["nameKeyboard"] = ZO_CachedStrFormat(SI_ZONE_NAME, newLocationName)
				locs2[i]["nameGamepad"] = ZO_CachedStrFormat(SI_ZONE_NAME, newLocationName)
			end
		end
	end
	
	for i = 1, #locs3 do	   
	   newLocationName = locationNames[zo_strlower(locs3[i]["rawName"])]
	   
	   if newLocationName ~= nil then
			if (EsoBR.Settings.ShowLocations == "Português+Inglês") then
				if string.find(locs3[i]["nameKeyboard"], "target_veteranRank_icon") then
					locs3[i]["nameKeyboard"] = "|t100%:100%:EsoUI/Art/UnitFrames/target_veteranRank_icon.dds|t " .. ZO_CachedStrFormat(SI_ZONE_NAME, locs3[i]["rawName"] .. " (" .. newLocationName .. ")")
				end
				if string.find(locs3[i]["nameGamepad"], "^Loch weterana") then
					locs3[i]["nameGamepad"] = "Loch weterana " .. locs3[i]["rawName"] .. " (" .. newLocationName .. ")"
				end
			elseif (EsoBR.Settings.ShowLocations == "Somente Português") then
				if string.find(locs3[i]["nameKeyboard"], "target_veteranRank_icon") then
					locs3[i]["nameKeyboard"] = "|t100%:100%:EsoUI/Art/UnitFrames/target_veteranRank_icon.dds|t " .. ZO_CachedStrFormat(SI_ZONE_NAME, locs3[i]["rawName"])
				end
				if string.find(locs3[i]["nameGamepad"], "^Loch weterana") then
					locs3[i]["nameGamepad"] = "Loch weterana " .. locs3[i]["rawName"]
				end
			elseif (EsoBR.Settings.ShowLocations == "Inglês+Português") then
				if string.find(locs3[i]["nameKeyboard"], "target_veteranRank_icon") then
					locs3[i]["nameKeyboard"] = "|t100%:100%:EsoUI/Art/UnitFrames/target_veteranRank_icon.dds|t " .. ZO_CachedStrFormat(SI_ZONE_NAME, newLocationName .. " (" .. locs3[i]["rawName"] .. ")")
				end
				if string.find(locs3[i]["nameGamepad"], "^Loch weterana") then
					locs3[i]["nameGamepad"] = "Loch weterana " .. newLocationName .. " (" .. locs3[i]["rawName"] .. ")"
				end
			else
				if string.find(locs3[i]["nameKeyboard"], "target_veteranRank_icon") then
					locs3[i]["nameKeyboard"] = "|t100%:100%:EsoUI/Art/UnitFrames/target_veteranRank_icon.dds|t " .. ZO_CachedStrFormat(SI_ZONE_NAME, newLocationName)
				end
				if string.find(locs3[i]["nameGamepad"], "^Loch weterana") then
					locs3[i]["nameGamepad"] = "Loch weterana " .. newLocationName
				end
			end
		end
	end
end

function EsoBR_doubleNamesMateriais(EsoBR)

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local coletaveis = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (coletaveis == nil or EsoBR.Settings.ShowMateriais == "Somente Português") then
			return coletaveis
		end
		
		newMatName = materiaisNames[zo_strlower(coletaveis)]
			
		if newMatName ~= nil then
			if (EsoBR.Settings.ShowMateriais == "Português+Inglês") then
				coletaveis = coletaveis .. "\n|ca99e83" .. newMatName .. "|r"
			elseif (EsoBR.Settings.ShowMateriais == "Inglês+Português") then
				coletaveis = newMatName .. "\n|ca99e83" .. coletaveis .. "|r"
			else
				coletaveis = newMatName
			end
		end
			
		return coletaveis
	end
	
	--[[local GetItemLinkOld = GetItemLinkName
	
	function GetItemLinkName(...)
		local coletaveis2 = ZO_CachedStrFormat(GetItemLinkOld(...))
		
		if (coletaveis2 == nil or EsoBR.Settings.ShowMateriais == "Somente Português") then
			return coletaveis2
		end
		
		newMatName = materiaisNames[zo_strlower(coletaveis2)]
			
		if newMatName ~= nil then
			if (EsoBR.Settings.ShowMateriais == "Português+Inglês") then
				coletaveis2 = coletaveis2 .. "\n|ca99e83" .. newMatName .. "|r"
			elseif (EsoBR.Settings.ShowMateriais == "Inglês+Português") then
				coletaveis2 = newMatName .. "\n|ca99e83" .. coletaveis2 .. "|r"
			else
				coletaveis2 = newMatName
			end
		end
			
		return coletaveis2
	end--]]
		
		
		
	EsoBR_doubleNamesMateriais = nil
end

function EsoBR_doubleNamesConjuntos(EsoBR)

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local conjunto = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (conjunto == nil or EsoBR.Settings.ShowConjuntos == "Somente Português") then
			return conjunto
		end
		
		newConjName = conjuntosNames[zo_strlower(conjunto)]
			
		if newConjName ~= nil then
			if (EsoBR.Settings.ShowConjuntos == "Português+Inglês") then
				conjunto = conjunto .. "\n|ca99e83" .. newConjName .. "|r"
			elseif (EsoBR.Settings.ShowConjuntos == "Inglês+Português") then
				conjunto = newConjName .. "\n|ca99e83" .. conjunto .. "|r"
			else
				conjunto = newConjName
			end
		end
			
		return conjunto
	end

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	--[[local GetItemLinkNameOld = GetItemLinkName
	
	function GetItemLinkName(...)
		local conjunto2 = ZO_CachedStrFormat(GetItemLinkNameOld(...))
		
		if (conjunto2 == nil or EsoBR.Settings.ShowConjuntos == "Somente Português") then
			return conjunto2
		end
		
		newConjName = conjuntosNames[zo_strlower(conjunto2)]
			
		if newConjName ~= nil then
			if (EsoBR.Settings.ShowConjuntos == "Português+Inglês") then
				conjunto2 = conjunto2 .. "\n|ca99e83" .. newConjName .. "|r"
			elseif (EsoBR.Settings.ShowConjuntos == "Inglês+Português") then
				conjunto2 = newConjName .. "\n|ca99e83" .. conjunto2 .. "|r"
			else
				conjunto2 = newConjName
			end
		end
			
		return conjunto2
	end--]]
	
	EsoBR_doubleNamesConjuntos = nil
end

function EsoBR_doubleNamesItens(EsoBR)
		
	
		
	EsoBR_doubleNamesItens = nil
end

function EsoBR_doubleNamesBebidaseComidas(EsoBR)

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local usaveis = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (usaveis == nil or EsoBR.Settings.ShowBebiComi == "Somente Português") then
			return usaveis
		end
		
		newBebName = bebcomNames[zo_strlower(usaveis)]
			
		if newBebName ~= nil then
			if (EsoBR.Settings.ShowBebiComi == "Português+Inglês") then
				usaveis = usaveis .. "\n|ca99e83" .. newBebName .. "|r"
			elseif (EsoBR.Settings.ShowBebiComi == "Inglês+Português") then
				usaveis = newBebName .. "\n|ca99e83" .. usaveis .. "|r"
			else
				usaveis = newBebName
			end
		end
			
		return usaveis
	end
	
	--[[local GetItemLinkNameOld = GetItemLinkName
	
	function GetItemLinkName(...)
		local usaveis2 = ZO_CachedStrFormat(GetItemLinkNameOld(...))
		
		if (usaveis2 == nil or EsoBR.Settings.ShowBebiComi == "Somente Português") then
			return usaveis2
		end
		
		newBebName = bebcomNames[zo_strlower(usaveis2)]
			
		if newBebName ~= nil then
			if (EsoBR.Settings.ShowBebiComi == "Português+Inglês") then
				usaveis2 = usaveis2 .. "\n|ca99e83" .. newBebName .. "|r"
			elseif (EsoBR.Settings.ShowBebiComi == "Inglês+Português") then
				usaveis2 = newBebName .. "\n|ca99e83" .. usaveis2 .. "|r"
			else
				usaveis2 = newBebName
			end
		end
			
		return usaveis2
	end--]]
	
	EsoBR_doubleNamesBebidaseComidas = nil
end

function EsoBR_doubleNamesEnglishSearch(EsoBR)
			
		
	
	EsoBR_doubleNamesEnglishSearch = nil
end

function EsoBR_doubleNamesChampion(EsoBR)
	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
			
		local GetChampionSkillNameOld = GetChampionSkillName
	
		function GetChampionSkillName(...)
			local championSkillId = ...
			local abilityId = GetChampionAbilityId(championSkillId)
			local ptbrName = GetChampionSkillNameOld(...)
			
			if EsoBR.Settings.ShowChampionTooltip == "Somente Português" or not abilityId then
				return ptbrName
			end
			
			if not abilityId or not EsoBR_habilidades[abilityId] then
				return ptbrName
			end
			
			if EsoBR.Settings.ShowChampionTooltip == "Português+Inglês" then
				return string.format(ptbrName .. "\n|ca99e83(" .. EsoBR_habilidades[abilityId].. ")" )
			elseif EsoBR.Settings.ShowChampionTooltip == "Inglês+Português" then
				return string.format(EsoBR_habilidades[abilityId] .. "\n|ca99e83(" ..  ptbrName .. ")")
			else
				return EsoBR.Settings.ShowChampionTooltip[abilityId]
			end
		end
		
		-- Tooltips
		
		local function getIdFromSkillId(championSkillId)
			local abilityId = GetChampionAbilityId(championSkillId)
			local ptbrName = GetChampionSkillNameOld(championSkillId)
			
			return abilityId, ptbrName
		end
		
		local function getIdFromAbilityId(abilityId)
			local ptbrName = GetAbilityName(abilityId)
			
			return abilityId, ptbrName
		end
		
		local function modifyTooltip(abilityId, ptbrName)
			
			local finalName
			
			if EsoBR.Settings.ShowChampionTooltip ~= "Somente Português" and abilityId and EsoBR_habilidades[abilityId] and ptbrName then					
				if EsoBR.Settings.ShowChampionTooltip == "Português+Inglês" then
					finalName = string.format(ptbrName .. "\n|ca99e83(" .. EsoBR_habilidades[abilityId].. ")" )
				elseif EsoBR.Settings.ShowChampionTooltip == "Inglês+Português" then
					finalName = string.format(EsoBR_habilidades[abilityId] .. "\n|ca99e83(" ..  ptbrName .. ")")
				else
					finalName = EsoBR_habilidades[abilityId]
				end
				
				if finalName then
					SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10)
				end
			end
		end
		
		local function abilityTooltipHook(tooltipControl, method, linkFunc)
			local origMethod = tooltipControl[method]
			tooltipControl[method] = function(self, ...)
				
				modifyTooltip(linkFunc(...))
				
				origMethod(self, ...)
				
				SafeAddString(SI_ABILITY_TOOLTIP_NAME, EsoBR.StringsBackup["SI_ABILITY_TOOLTIP_NAME"], 10)
			end
		end
		
		abilityTooltipHook(ChampionSkillTooltip, "SetChampionSkill", getIdFromSkillId)
		abilityTooltipHook(ChampionSkillTooltip, "SetAbilityId", getIdFromAbilityId)
		ZO_PreHook(CHAMPION_PERKS, "LayoutRightTooltipChampionSkillAbility", function(tooltip, ...)   modifyTooltip(...) end)
		ZO_PostHook(CHAMPION_PERKS, "LayoutRightTooltipChampionSkillAbility", function() SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10) end)
	
	EsoBR_doubleNamesChampion = nil
end

function EsoBR_doubleNamesHabilidades(EsoBR)
	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
				
		ZO_SkillsMorphDialog:SetHandler("OnShow", function()
			
			local bsAbility = ZO_SkillsMorphDialog:GetNamedChild("BaseAbility")
			local skillProgressionData = bsAbility.skillProgressionData
			local currentAbilityId = skillProgressionData:GetAbilityId()
			
			if EsoBR_habilidades[currentAbilityId] then
				ZO_SkillsMorphDialog.desc:SetText(zo_strformat(SI_SKILLS_SELECT_MORPH, EsoBR_habilidades[currentAbilityId]))
			end
		end)
			
		-- Tooltips
		
		local function modifyTooltip(isPassive, isNew, ...)
			local finalName, finalName2, ptbrName
			
			if EsoBR.Settings.ShowHabilidadesTooltip ~= "Somente Português" then
				if isPassive then
					local skillType, skillLineIndex, skillIndex, rank = ...
					local abilityId = GetSpecificSkillAbilityInfo(skillType, skillLineIndex, skillIndex, 0, rank)
					
					if abilityId and EsoBR_habilidades[abilityId] then
						ptbrName = GetAbilityName(abilityId)
						finalName = EsoBR_habilidades[abilityId]
					end
				elseif isNew then
					local skillType, skillLineIndex, skillIndex = ...
					local abilityId = GetSpecificSkillAbilityInfo(skillType, skillLineIndex, skillIndex, 0, 1)
					
					if abilityId and EsoBR_habilidades[abilityId] then
						ptbrName = GetAbilityName(abilityId)
						finalName = EsoBR_habilidades[abilityId]
					end
				else
					local skillType, skillLineIndex, skillIndex, morphChoice, _, _, _, _, _, _, _, _, _, overrideAbilityId = ...
					local abilityId = GetSpecificSkillAbilityInfo(skillType, skillLineIndex, skillIndex, morphChoice, 1)
					
					if overrideAbilityId and EsoBR_habilidades[overrideAbilityId] then
						finalName = EsoBR_habilidades[overrideAbilityId]
						ptbrName = GetAbilityName(overrideAbilityId)
					elseif overrideAbilityId and not EsoBR_habilidades[overrideAbilityId] then
						-- finalName2 = nmIcon .. EsoBR_habilidades[abilityId]
					elseif abilityId and EsoBR_habilidades[abilityId] then
						finalName = EsoBR_habilidades[abilityId]
						ptbrName = GetAbilityName(abilityId)
					end
				end
				
				if finalName and ptbrName then
					if EsoBR.Settings.ShowHabilidadesTooltip == "Português+Inglês" then
						finalName = string.format(ptbrName .. "\n|ca99e83(" .. finalName .. ")")
					elseif EsoBR.Settings.ShowHabilidadesTooltip == "Inglês+Português" then
						finalName = string.format(finalName .. "\n|ca99e83(" .. ptbrName .. ")")
					end
					
					SafeAddString(SI_ABILITY_NAME_AND_RANK, GetString(SI_ABILITY_NAME_AND_RANK):gsub("<<1>>", finalName), 10)
					SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10)
				end
			end
		end
		
		local function modifyTooltipCompanion(...)
			local finalName, ptbrName
			
			if EsoBR.Settings.ShowHabilidadesTooltip ~= "Somente Português" then
				local abilityId = ...
				
				if abilityId and EsoBR_habilidades[abilityId] then
					ptbrName = GetAbilityName(abilityId)
					finalName = EsoBR_habilidades[abilityId]
				end
				
				if finalName and ptbrName then
					if EsoBR.Settings.ShowHabilidadesTooltip == "Português+Inglês" then
						finalName = string.format(ptbrName .. "\n|ca99e83(" .. finalName .. ")")
					elseif EsoBR.Settings.ShowHabilidadesTooltip == "Inglês+Português" then
						finalName = string.format(finalName .. "\n|ca99e83(" .. ptbrName .. ")")
					end
					
					SafeAddString(SI_ABILITY_NAME_AND_RANK, GetString(SI_ABILITY_NAME_AND_RANK):gsub("<<1>>", finalName), 10)
					SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10)
				end
			end
		end
		
		local function abilityTooltipHook(tooltipControl, method, isPassive, isNew, isCompanion)
			local origMethod = tooltipControl[method]
			tooltipControl[method] = function(self, ...)
				
				if isCompanion then
					modifyTooltipCompanion(...)
				else
					modifyTooltip(isPassive, isNew, ...)
				end
				
				origMethod(self, ...)
					
				SafeAddString(SI_ABILITY_NAME_AND_RANK, EsoBR.StringsBackup["SI_ABILITY_NAME_AND_RANK"], 10)
				SafeAddString(SI_ABILITY_TOOLTIP_NAME, EsoBR.StringsBackup["SI_ABILITY_TOOLTIP_NAME"], 10)
			end
		end
		
		abilityTooltipHook(SkillTooltip, "SetActiveSkill", false, false, false)
		abilityTooltipHook(SkillTooltip, "SetPassiveSkill", true, false, false)
		abilityTooltipHook(SkillTooltip, "SetSkillAbility", false, true, false)
		abilityTooltipHook(SkillTooltip, "SetCompanionSkill", false, false, true)
			
		local oldFunction = ZO_SkillProgressionData_Base.GetName
		
		function ZO_SkillProgressionData_Base:GetName()
			if EsoBR_habilidades[self:GetAbilityId()] and IsInGamepadPreferredMode() then
				return EsoBR_habilidades[self:GetAbilityId()]
			else
				return oldFunction(self)
			end
		end
		
		local oldFunction4 = ZO_SkillProgressionData_Base.GetFormattedName
		
		function ZO_SkillProgressionData_Base:GetFormattedName(formatter)
			if EsoBR_habilidades[self:GetAbilityId()] and IsInGamepadPreferredMode() then
				return ZO_CachedStrFormat(formatter or SI_ABILITY_NAME, EsoBR_habilidades[self:GetAbilityId()])
			else
				return oldFunction(self)
			end
		end
		
	EsoBR_doubleNamesHabilidades = nil
end