local function EsoBR_doubleNamesBoth(EsoBR)
	local GetGameCameraInteractableActionInfoOld = GetGameCameraInteractableActionInfo
	local prevInteractNpcEn = ""
	local prevInteractNpcBr = ""
		
	function GetGameCameraInteractableActionInfo(...)
		local action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink = GetGameCameraInteractableActionInfoOld()
		local newNpcName, temp1, temp2, interactionType, settingType
				
		if action == GetString(SI_GAMECAMERAACTIONTYPE2) or action == GetString(SI_GAMECAMERAACTIONTYPE21) or action == GetString(SI_GAMECAMERAACTIONTYPE1) or action == GetString(SI_GAMECAMERAACTIONTYPE7) then
			interactionType = "npc"
			settingType = EsoBR.Settings.ShowNPC
		else
			interactionType = "location"
			settingType = EsoBR.Settings.ShowMatColeta
		end
		
		if settingType == "br" or interactableName == nil then
			return action, ZO_CachedStrFormat(SI_ZONE_NAME, interactableName), interactionBlocked, isOwned, additionalInteractInfo, context, contextLink
		end
		
		temp1 = prevInteractNpcBr .. " (" .. prevInteractNpcEn .. ")"
		temp2 = prevInteractNpcEn .. " (" .. prevInteractNpcBr .. ")"
		
		if interactableName == prevInteractNpcBr or interactableName == temp1 or interactableName == temp2 then
			newNpcName = prevInteractNpcEn
		elseif interactableName == prevInteractNpcEn and settingType == "en" then
			newNpcName = prevInteractNpcEn
		else
			if interactionType == "npc" then
				newNpcName = npcNames[zo_strlower(interactableName)]
			else
				newNpcName = coletaveisNames[zo_strlower(interactableName)]
			end
				
			if (newNpcName ~= nil and interactableName ~= nil) then
				prevInteractNpcEn = newNpcName
				prevInteractNpcBr = interactableName
			end
		end
		
		if newNpcName ~= nil then
			if (settingType == "bren") then
				interactableName = ZO_CachedStrFormat(SI_ZONE_NAME, interactableName) .. "\n|ce0d210" .. newNpcName
			elseif (settingType == "enbr") then
				interactableName = newNpcName .. "\n|ce0d210" .. ZO_CachedStrFormat(SI_ZONE_NAME, interactableName) 
			else
				interactableName = newNpcName
			end 
		end
		
		return action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink
	end
	
	EsoBR_doubleNamesBoth = nil
end

local function EsoBR_doubleNamesMatColeta(EsoBR)
	
	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
		
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local matColeta = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (matColeta == nil or EsoBR.Settings.ShowMatColeta == "br") then
			return matColeta
		end
		
		newColName = coletaveisNames[zo_strlower(matColeta)]
			
		if newColName ~= nil then
			if (EsoBR.Settings.ShowMatColeta == "bren") then
				matColeta = matColeta .. "\n|ca99e83" .. newColName .. "|r"
			elseif (EsoBR.Settings.ShowMatColeta == "enbr") then
				matColeta = newColName .. "\n|ca99e83" .. matColeta .. "|r"
			else
				matColeta = newColName
			end
		end
			
		return matColeta
	end
	
	EsoBR_doubleNamesMatColeta = nil
end

function EsoBR_doubleNamesMateriais(EsoBR)

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local coletaveis = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (coletaveis == nil or EsoBR.Settings.ShowMateriais == "br") then
			return coletaveis
		end
		
		newMatName = materiaisNames[zo_strlower(coletaveis)]
			
		if newMatName ~= nil then
			if (EsoBR.Settings.ShowMateriais == "bren") then
				coletaveis = coletaveis .. "\n|ca99e83" .. newMatName .. "|r"
			elseif (EsoBR.Settings.ShowMateriais == "enbr") then
				coletaveis = newMatName .. "\n|ca99e83" .. coletaveis .. "|r"
			else
				coletaveis = newMatName
			end
		end
			
		return coletaveis
	end
	
	--[[local GetItemLinkOld = GetItemLinkName
	
	function GetItemLinkName(...)
		local coletaveis2 = ZO_CachedStrFormat(GetItemLinkOld(...))
		
		if (coletaveis2 == nil or EsoBR.Settings.ShowMateriais == "br") then
			return coletaveis2
		end
		
		newMatName = materiaisNames[zo_strlower(coletaveis2)]
			
		if newMatName ~= nil then
			if (EsoBR.Settings.ShowMateriais == "bren") then
				coletaveis2 = coletaveis2 .. "\n|ca99e83" .. newMatName .. "|r"
			elseif (EsoBR.Settings.ShowMateriais == "enbr") then
				coletaveis2 = newMatName .. "\n|ca99e83" .. coletaveis2 .. "|r"
			else
				coletaveis2 = newMatName
			end
		end
			
		return coletaveis2
	end--]]
		
		
		
	EsoBR_doubleNamesMateriais = nil
end

function EsoBR_doubleNamesConjuntos(EsoBR)

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local conjunto = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (conjunto == nil or EsoBR.Settings.ShowConjuntos == "br") then
			return conjunto
		end
		
		newConjName = conjuntosNames[zo_strlower(conjunto)]
			
		if newConjName ~= nil then
			if (EsoBR.Settings.ShowConjuntos == "bren") then
				conjunto = conjunto .. "\n|ca99e83" .. newConjName .. "|r"
			elseif (EsoBR.Settings.ShowConjuntos == "enbr") then
				conjunto = newConjName .. "\n|ca99e83" .. conjunto .. "|r"
			else
				conjunto = newConjName
			end
		end
			
		return conjunto
	end

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	--[[local GetItemLinkNameOld = GetItemLinkName
	
	function GetItemLinkName(...)
		local conjunto2 = ZO_CachedStrFormat(GetItemLinkNameOld(...))
		
		if (conjunto2 == nil or EsoBR.Settings.ShowConjuntos == "br") then
			return conjunto2
		end
		
		newConjName = conjuntosNames[zo_strlower(conjunto2)]
			
		if newConjName ~= nil then
			if (EsoBR.Settings.ShowConjuntos == "bren") then
				conjunto2 = conjunto2 .. "\n|ca99e83" .. newConjName .. "|r"
			elseif (EsoBR.Settings.ShowConjuntos == "enbr") then
				conjunto2 = newConjName .. "\n|ca99e83" .. conjunto2 .. "|r"
			else
				conjunto2 = newConjName
			end
		end
			
		return conjunto2
	end--]]
	
	EsoBR_doubleNamesConjuntos = nil
end

function EsoBR_doubleNamesBebidaseComidas(EsoBR)

	if EsoBR_doubleNamesBoth then
		EsoBR_doubleNamesBoth(EsoBR)
	end
	
	local GetItemNameOld = GetItemName
	
	function GetItemName(...)
		local usaveis = ZO_CachedStrFormat(GetItemNameOld(...))
		
		if (usaveis == nil or EsoBR.Settings.ShowBebiComi == "br") then
			return usaveis
		end
		
		newBebName = bebcomNames[zo_strlower(usaveis)]
			
		if newBebName ~= nil then
			if (EsoBR.Settings.ShowBebiComi == "bren") then
				usaveis = usaveis .. "\n|ca99e83" .. newBebName .. "|r"
			elseif (EsoBR.Settings.ShowBebiComi == "enbr") then
				usaveis = newBebName .. "\n|ca99e83" .. usaveis .. "|r"
			else
				usaveis = newBebName
			end
		end
			
		return usaveis
	end
	
	--[[local GetItemLinkNameOld = GetItemLinkName
	
	function GetItemLinkName(...)
		local usaveis2 = ZO_CachedStrFormat(GetItemLinkNameOld(...))
		
		if (usaveis2 == nil or EsoBR.Settings.ShowBebiComi == "br") then
			return usaveis2
		end
		
		newBebName = bebcomNames[zo_strlower(usaveis2)]
			
		if newBebName ~= nil then
			if (EsoBR.Settings.ShowBebiComi == "bren") then
				usaveis2 = usaveis2 .. "\n|ca99e83" .. newBebName .. "|r"
			elseif (EsoBR.Settings.ShowBebiComi == "enbr") then
				usaveis2 = newBebName .. "\n|ca99e83" .. usaveis2 .. "|r"
			else
				usaveis2 = newBebName
			end
		end
			
		return usaveis2
	end--]]
	
	EsoBR_doubleNamesBebidaseComidas = nil
end