function EsoBR_doubleNamesChampion(EsoBR)
	if EsoBR:GetLanguage() == "br" then
		local rsd = EsoBR.Settings.Data
		
		local GetChampionSkillNameOld = GetChampionSkillName
	
		function GetChampionSkillName(...)
			local championSkillId = ...
			local abilityId = GetChampionAbilityId(championSkillId)
			local brsName = GetChampionSkillNameOld(...)
			
			if EsoBR.Settings.ShowChampionTooltip == "br" or not abilityId then
				return brsName
			end
			
			if not abilityId or not rsd.Abilities[abilityId] then
				return brsName
			end
			
			if EsoBR.Settings.ShowChampionTooltip == "bren" then
				return string.format("%s \n|ca99e83 (%s)", brsName, rsd.Abilities[abilityId]) --(%s) |ca99e83 (%s)
			elseif EsoBR.Settings.ShowChampionTooltip == "enbr" then
				return string.format("%s \n|ca99e83 (%s)", rsd.Abilities[abilityId], brsName)
			else
				return EsoBR.Settings.Data.Abilities[abilityId]
			end
		end
		
		-- Tooltips
		
		local function getIdFromSkillId(championSkillId)
			local abilityId = GetChampionAbilityId(championSkillId)
			local brsName = GetChampionSkillNameOld(championSkillId)
			
			return abilityId, brsName
		end
		
		local function getIdFromAbilityId(abilityId)
			local brsName = GetAbilityName(abilityId)
			
			return abilityId, brsName
		end
		
		local function modifyTooltip(abilityId, brsName)
			
			local finalName
			
			if EsoBR.Settings.ShowChampionTooltip ~= "br" and abilityId and rsd.Abilities[abilityId] and brsName then					
				if EsoBR.Settings.ShowChampionTooltip == "bren" then
					finalName = string.format("%s \n|ca99e83 (%s)", brsName, rsd.Abilities[abilityId])
				elseif EsoBR.Settings.ShowChampionTooltip == "enbr" then
					finalName = string.format("%s \n|ca99e83 (%s)", rsd.Abilities[abilityId], brsName)
				else
					finalName = rsd.Abilities[abilityId]
				end
				
				if finalName then
					SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10)
				end
			end
		end
		
		local function abilityTooltipHook(tooltipControl, method, linkFunc)
			local origMethod = tooltipControl[method]
			tooltipControl[method] = function(self, ...)
				
				modifyTooltip(linkFunc(...))
				
				origMethod(self, ...)
				
				SafeAddString(SI_ABILITY_TOOLTIP_NAME, EsoBR.StringsBackup["SI_ABILITY_TOOLTIP_NAME"], 10)
			end
		end
		
		abilityTooltipHook(ChampionSkillTooltip, "SetChampionSkill", getIdFromSkillId)
		abilityTooltipHook(ChampionSkillTooltip, "SetAbilityId", getIdFromAbilityId)
		ZO_PreHook(CHAMPION_PERKS, "LayoutRightTooltipChampionSkillAbility", function(tooltip, ...)   modifyTooltip(...) end)
		ZO_PostHook(CHAMPION_PERKS, "LayoutRightTooltipChampionSkillAbility", function() SafeAddString(SI_ABILITY_TOOLTIP_NAME, finalName, 10) end)
	end
	EsoBR_doubleNamesChampion = nil
end