function EsoBR_doubleNamesCollections(EsoBR)
	if EsoBR:GetLanguage() == "br" then
		
		local localSets = EsoBR.Settings.Data.Sets
		
		ZO_PreHook(ZO_ItemSetCollectionsDataManager,    "UpdateSearchResults", function(tooltip)
			local searchString = zo_strlower(tooltip.searchString)
			
			if EsoBR.Settings.EnglishSearch and searchString ~= "" and searchString ~= nil and zo_strmatch(searchString, "[a-z]") ~= nil then
				local nextNumber = tooltip.searchResultsVersion + 1
				local localSets = EsoBR.Settings.Data.Sets
				
				for index,value in pairs(localSets) do
					if zo_strfind(zo_strlower(value), searchString) ~= nil and tooltip:GetItemSetCollectionData(index) then
						local itemSetCollectionData = tooltip:GetItemSetCollectionData(index)
						itemSetCollectionData:SetSearchResultsVersion(nextNumber)
					end
				end
			end
		end)
		
		-- Third-party Compatibility
		-- Item Set Browser
		if ItemBrowserList then
			local ItemBrowserListProcessItemEntryOld = ItemBrowserList.ProcessItemEntry
			
			function ItemBrowserList:ProcessItemEntry(...)
				local stringSearch, data, searchTerm = ...
				if (localSets[data.setId] and zo_plainstrfind(localSets[data.setId]:lower(), searchTerm)) then
					return true
				end
				
				return ItemBrowserListProcessItemEntryOld(self, ...)
			end
		end
		-- Third-party Compatibility
		
		for index, value in pairs(ITEM_SET_COLLECTIONS_DATA_MANAGER.itemSetCollections) do
			value.GetRawName = function()				
				if (EsoBR.Settings.ShowCollectionsSetsMenu == "br" or not localSets[value.itemSetId]) then
					return GetItemSetName(value.itemSetId)
				elseif (EsoBR.Settings.ShowCollectionsSetsMenu == "bren") then
					return GetItemSetName(value.itemSetId) .. " |cffffff(" .. localSets[value.itemSetId] .. ")"
				elseif (EsoBR.Settings.ShowCollectionsSetsMenu == "enbr") then
					return localSets[value.itemSetId] .. " |cffffff(" .. GetItemSetName(value.itemSetId) .. ")"
				end
				
				return localSets[value.itemSetId]
			end
		end
		
		local function itemTooltipHook(tooltipControl, method)
			local origMethod = tooltipControl[method]
			tooltipControl[method] = function(self, ...)
				
				local finalSet = localSets[...]
				local brsSet = GetItemSetName(...)
				
				if EsoBR.Settings.ShowItemsSetsTooltip ~= "br" and finalSet then
					
					if EsoBR.Settings.ShowItemsSetsTooltip == "bren" then
						finalSet = string.format("|ca99e83%s \n|cffffff(%s)", brsSet, finalSet)
					elseif EsoBR.Settings.ShowItemsSetsTooltip == "enbr" then
						finalSet = string.format("|ca99e83%s \n|cffffff(%s)", finalSet, brsSet)
					end
					
					SafeAddString(SI_ITEM_FORMAT_STR_SET_NAME_NO_COUNT, ZO_CachedStrFormat(SI_ITEM_FORMAT_STR_SET_NAME_NO_COUNT, finalSet), 10)
				end
				
				origMethod(self, ...)
					
				SafeAddString(SI_ITEM_FORMAT_STR_SET_NAME_NO_COUNT, EsoBR.StringsBackup["SI_ITEM_FORMAT_STR_SET_NAME_NO_COUNT"], 10)
			end
		end
		
		itemTooltipHook(ItemTooltip, "SetGenericItemSet")
	end
	
	EsoBR_doubleNamesCollections = nil
end