function EsoBR_doubleNamesBoth(EsoBR)
	local GetGameCameraInteractableActionInfoOld = GetGameCameraInteractableActionInfo
	local prevInteractNpcEn = ""
	local prevInteractNpcBr = ""
	
	function GetGameCameraInteractableActionInfo(...)		
		local action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract = GetGameCameraInteractableActionInfoOld()
		local newNpcName, temp1, temp2, interactionType, settingType
		
		if action == GetString(SI_GAMECAMERAACTIONTYPE2) or action == GetString(SI_GAMECAMERAACTIONTYPE21) or action == GetString(SI_GAMECAMERAACTIONTYPE1) or action == GetString(SI_GAMECAMERAACTIONTYPE7) then
			interactionType = "npc"
			settingType = EsoBR.Settings.ShowNPC
		elseif action == GetString(SI_GAMECAMERAACTIONTYPE5) then
			interactionType = "craft"
			settingType = EsoBR.Settings.ShowCraft
		end
		
		if not settingType or settingType == "br" or interactableName == nil then
			return action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract
		end
		
		if interactionType == "npc" then
			if interactableName == prevInteractNpcBr then
				newNpcName = prevInteractNpcEn
			else
				newNpcName = npcNames[zo_strlower(interactableName)]
				
				if newNpcName == nil then
					return action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract
				end
					
				if interactableName ~= nil then
					prevInteractNpcEn = newNpcName
					prevInteractNpcBr = interactableName
				end
			end
			
			if newNpcName ~= interactableName then
				if settingType == "bren" then
					interactableName = ZO_CachedStrFormat(SI_ZONE_NAME, interactableName) .. "\n" .. newNpcName
				elseif (settingType == "enbr") then
					interactableName = newNpcName .. "\n" .. ZO_CachedStrFormat(SI_ZONE_NAME, interactableName)
				else
					interactableName = newNpcName
				end
			end
		elseif interactionType == "craft" then
			local brName = string.match(interactableName, "%((.*)%)$")
			
			if interactableName == prevInteractNpcBr then
				newNpcName = prevInteractNpcEn
			else				
				if brName and EsoBR.Settings.Data.SetsNames[zo_strlower(brName)] then
					newNpcName = EsoBR.Settings.Data.SetsNames[zo_strlower(brName)] -- EsoBR:MagicReplace(interactableName, brName, EsoBR.Settings.Data.SetsNames[zo_strlower(brName)])
				end
				
				if newNpcName == nil then
					return action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract
				end
					
				if interactableName ~= nil then
					prevInteractNpcEn = newNpcName
					prevInteractNpcBr = interactableName
				end
			end
			
			if newNpcName ~= interactableName and brName then
				local firstPart = string.match(interactableName, "^(.*) %(")
				
				if settingType == "bren" then
					interactableName = string.format("%s (%s) |ca99e83 (%s)", firstPart, brName, EsoBR.Settings.Data.SetsNames[zo_strlower(brName)])
				elseif (settingType == "enbr") then
					interactableName = string.format("%s (%s) |ca99e83 (%s)", firstPart, EsoBR.Settings.Data.SetsNames[zo_strlower(brName)], brName)
				else
					interactableName = string.format("%s (%s)", firstPart, EsoBR.Settings.Data.SetsNames[zo_strlower(brName)])
				end
			end
		end
		
		return action, interactableName, interactionBlocked, isOwned, additionalInteractInfo, context, contextLink, isCriminalInteract
	end
	
	EsoBR_doubleNamesBoth = nil
end